#ifndef PSF_BINARY_DESERIALIZER_HPP
#define PSF_BINARY_DESERIALIZER_HPP

#include "DeSerializer.hpp"

namespace PSF
{
	class CBinaryDeSerializer : public IDeSerializer
	{
	public:
		CBinaryDeSerializer( std::istream& i_istream, bool i_bSearch = true);
		virtual ~CBinaryDeSerializer();

		virtual bool DeSerialize( int& o_out);
		virtual bool DeSerialize( unsigned int& o_out);
		virtual bool DeSerialize( bool& o_out);
		virtual bool DeSerialize( char& o_out);
		virtual bool DeSerialize( unsigned char& o_out);
		virtual bool DeSerialize( short& o_out);
		virtual bool DeSerialize( unsigned short& o_out);
		virtual bool DeSerialize( long& o_out);
		virtual bool DeSerialize( unsigned long& o_out);
		virtual bool DeSerialize( float& o_out);
		virtual bool DeSerialize( double& o_out);
		// same as double
		// virtual bool DeSerialize( long double& o_out);
		virtual bool DeSerialize( wchar_t& o_out);

		virtual std::auto_ptr<IDeSerializer> DeSerializeCompound( const std::wstring& i_wstrName, const Loki::TypeInfo& i_type);
		virtual std::auto_ptr<IDeSerializer> DeSerializeRange( const std::wstring& i_wstrName, const Loki::TypeInfo& i_typeRange);
	protected:
		bool FindElement( const std::wstring& i_wstrName);

		std::istream& m_istream;
		size_t m_nStartPos;
		unsigned int m_nSize;
		bool m_bSearch;
	};
};
#endif