#include "StringUtil.hpp"
#include "Utils/utf16utf8_codecvt.h"
#include "Utils/convertstream.h"
#include <locale>

std::wostream& operator << ( std::wostream& i_wostream, const std::string& i_str)
{
	std::wstring wstr;
	Utility::CharWCharConvert( i_str.begin(), i_str.end(), std::back_inserter( wstr));
	return i_wostream.write( wstr.data(), wstr.size());
}

std::ostream& operator << ( std::ostream& i_ostream, const std::wstring& i_wstr)
{
	std::locale loc( std::locale(), new utf16utf8_codecvt);
	basic_oconvertstream<wchar_t, std::char_traits<wchar_t>, char, std::char_traits<char> > n;
    n.imbue(loc);
	n << i_wstr;
	return i_ostream << n.str();
}

//#include <ctime>
/*
void Utility::FormatDateString(unsigned int i_nDate, std::string& o_strOut)
{
	tm* ptm = localtime((time_t*)&i_nDate);

	std::string strMonth;
	switch (ptm->tm_mon)
	{
	case 0:
		strMonth = "Jan";
		break;
	case 1:
		strMonth = "Feb";
		break;
	case 2:
		strMonth = "Mar";
		break;
	case 3:
		strMonth = "Apr";
		break;
	case 4:
		strMonth = "May";
		break;
	case 5:
		strMonth = "Jun";
		break;
	case 6:
		strMonth = "Jul";
		break;
	case 7:
		strMonth = "Aug";
		break;
	case 8:
		strMonth = "Sep";
		break;
	case 9:
		strMonth = "Okt";
		break;
	case 10:
		strMonth = "Nov";
		break;
	case 11:
		strMonth = "Dec";
		break;
	default:
		break;
	}

	char* pszOut = new char[255];
	sprintf(pszOut, "%d. %s\n(%02d:%02d)", ptm->tm_mday, strMonth.c_str(), ptm->tm_hour, ptm->tm_min);
	o_strOut = pszOut;
	delete[] pszOut;
}

void Utility::FormatDateString(unsigned int i_nDate, std::wstring& o_wstrOut)
{
	std::string strTemp;
	FormatDateString(i_nDate, strTemp);
	o_wstrOut = StringToWString(strTemp);
}

void Utility::FormatDateStringHdr(unsigned int i_nDate, std::string& o_strOut)
{
	tm* ptm = localtime((time_t*)&i_nDate);

	std::string strMonth;
	switch (ptm->tm_mon)
	{
	case 0:
		strMonth = "Jan";
		break;
	case 1:
		strMonth = "Feb";
		break;
	case 2:
		strMonth = "Mar";
		break;
	case 3:
		strMonth = "Apr";
		break;
	case 4:
		strMonth = "May";
		break;
	case 5:
		strMonth = "Jun";
		break;
	case 6:
		strMonth = "Jul";
		break;
	case 7:
		strMonth = "Aug";
		break;
	case 8:
		strMonth = "Sep";
		break;
	case 9:
		strMonth = "Okt";
		break;
	case 10:
		strMonth = "Nov";
		break;
	case 11:
		strMonth = "Dec";
		break;
	default:
		break;
	}

	char* pszOut = new char[255];
	sprintf(pszOut, "%d. %s (%02d:%02d)", ptm->tm_mday, strMonth.c_str(), ptm->tm_hour, ptm->tm_min);
	o_strOut = pszOut;
	delete[] pszOut;
}

void Utility::FormatDateStringHdr(unsigned int i_nDate, std::wstring& o_wstrOut)
{
	std::string strTemp;
	FormatDateStringHdr(i_nDate, strTemp);
	o_wstrOut = StringToWString(strTemp);
}
*/